%define name dixi
%define rversion 0.2.27
%define release %mkrel 1

%define dixidir %{_datadir}/%{name}
%define xosdstagesdir %{_sysconfdir}/xos/config/xosd_stages
%define tomcathome %{_datadir}/tomcat5

Summary: Distributed XtreemOS Infrastructure
Name: %{name}
Version: %{rversion}
Release: %{release}
Source0: %{name}-%{rversion}.tar.bz2
Source1: axis2-kernel-1.2.jar
Source2: mina-core-1.1.5.jar
Source3: mina-filter-ssl-1.1.5.jar
Source4: velocity-dep-1.5.jar
Source5: slf4j-api-1.5.0.jar
Source6: slf4j-simple-1.5.0.jar
#Source7: log4j-over-slf4j-1.5.0.jar
Source8: setup_xosdconfig

License: GPL
Group: System/Cluster
Url: http://gforge.inria.fr/frs/shownotes.php?release_id=2115
BuildRoot: %{_tmppath}/%{name}-%{rversion}-%{release}-buildroot
BuildRequires: xos-devel xos-blcr-devel pam-devel
Buildrequires: libxml2-devel ant
BuildRequires: java-devel jpackage-utils
BuildRequires: xstream

%description
 * DIXI (DIstributed Xtreemos Infrastructure):
   * service code generation tools,
   * staging and communication daemons for running services,
 * AEM services (WP3.3 software)
 * certain VOM services (WP3.5 software):
   * VOPS,
   * RCA,
   * CDAMng (access interface for the CDA from DIXI).

%package devel
Group: System/Cluster
Summary: Developement package for dixi
Requires: dixi-main
%description devel
Developement package for dixi.

%package main
Group: System/Cluster
Summary: core classes needed to run DIXI, XATI and the services
Requires: log4j velocity testng easymock2 jmock1 hamcrest junit4 bouncycastle sunxacml
Requires: jpackage-utils
Requires: xstream
Requires: srds
Requires: %{name}-main-jardeps = %{version}
provides: dixi-main

%description main
The package contains the core classes needed to run DIXI, XATI and the services.

%package aemdemo
Group: System/Cluster
Summary: AEMDemo
%description aemdemo 
AEMDemo is an experiemental web based graphical interface for managing resource and jobs
running on top of tomcat. 


%package main-jardeps
Group: System/Cluster
Summary: Jar dependencies for dixi-main

%description main-jardeps
Jar dependencies for dixi-main

%package services
Group: System/Cluster
Summary: Classes implementing the main services, needed by other services
Requires: dixi-main

%description services
The classes implementing the main services, needed by other services.

%package xati
Group: System/Cluster
Summary: Collection of API and client-side access points for running clients
Requires: dixi-main
Obsoletes: dixi-cxati <= 0.2.7

%description xati
XATI, the collection of API and client-side access points for running clients.
It also contains sample client programs and scripts for running them.

%package cxati
Group: System/Cluster
Summary: Collection of API and client-side access points for running clients (written in C)
Requires: xmlstarlet

%description cxati
This package is similar to XATI, except that it provides the access
point and API for programs written in C.

%package aem-node
Group: System/Cluster
Summary: AEM (Application Execution Management) node side
Requires:  dixi-main, dixi-services, ganglia-core, pam_xos, credstore-utils
BuildRequires: credstore-devel

%description aem-node
AEM (Application Execution Management) is a collection of services which handles
user's job submissions, job directory, resource selection, resource reservation,
and job execution management. This package contains the node-level services which
provide services for execution management and resource monitoring.

%package aem-server
Group: System/Cluster
Summary: AEM (Application Execution Management) server side
Requires: dixi-main,  dixi-services

%description aem-server
AEM (Application Execution Management) is a collection of services which handles
user's job submissions, job directory, resource selection, resource reservation,
and job execution management. This package contains the core-level services which provide
the job management, job directory and resource management.

%package vom-rca-node
Group: System/Cluster
Summary: RCA (Resource Certification Authority) node side
Requires: dixi-main, dixi-services, rca
# depencies external JARs

%description vom-rca-node
RCA (Resource Certification Authority) provides the means for the resources
to register, be confirmed by an authorised administrator, and provide the 
digital certification for the node. This package contains the client-side
service which should run on each node capable of executing jobs.

%package vom-rca-server
Group: System/Cluster
Summary: RCA (Resource Certification Authority) server side
Requires: dixi-main, dixi-services, rca
# external JARs.

%description vom-rca-server
RCA (Resource Certification Authority) provides the means for the resources to
register, be confirmed by an authorised administrator, and provide the digital
certification for the node. This package contains the core-side service which
usually runs on one node within a physical organisation.

%package vom-vops
Group: System/Cluster
Summary: VOPS service provides means to store and manage VO-level policies
Requires: dixi-main,  dixi-services
# external JARs

%description vom-vops
The VOPS service provides means to store and manage VO-level policies, to obtain
the policy filters and the policy decisions on the VO level.

%package javadoc
Group: System/Cluster
Summary: Dixi javadoc

%description javadoc
DIXI javadoc

%prep
%setup -q

%build
ant build-java
ant build-c

%install
rm -rf $RPM_BUILD_ROOT
%{__mkdir_p} %{buildroot}%{_sbindir}
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{dixidir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/xos/truststore/certs/incoming
%{__mkdir_p} %{buildroot}%{_sysconfdir}/xos/truststore/private


ant -DDEST=%{buildroot} install
ant -DDEST=%{buildroot} AEMDemo-install

cp -p %{SOURCE1} %{buildroot}%{_javadir}/
cp -p %{SOURCE2} %{buildroot}%{_javadir}/
cp -p %{SOURCE3} %{buildroot}%{_javadir}/
cp -p %{SOURCE4} %{buildroot}%{_javadir}/
cp -p %{SOURCE5} %{buildroot}%{_javadir}/
cp -p %{SOURCE6} %{buildroot}%{_javadir}/
#cp %{SOURCE7} %{buildroot}%{_javadir}/


%{__mkdir_p} %{buildroot}%{dixidir}/libs
cd %{buildroot}%{_javadir}
for file in *.jar
do
  %{__ln_s} "%{_javadir}/$file" "%{buildroot}%{dixidir}/libs/$file"
done

# add links to required .jars
for file in bcprov.jar velocity.jar sunxacml.jar srds.jar oncrpc.jar \
	    jrpcgen.jar xstream.jar xpp3.jar \
	    commons-cli.jar ws-commons-util.jar servlet.jar
do 
  %{__ln_s} "%{_javadir}/$file" "%{buildroot}%{dixidir}/libs/$file"
done
%{__ln_s} %{_javadir}/scalaris/scalaris.jar %{buildroot}%{dixidir}/libs/scalaris.jar

cd -

%{__mkdir_p} %{buildroot}%{_bindir}
cd %{buildroot}%{_bindir}
for script in rca_apply rca_confirm rca_info rca_list_pending \
	rca_list_registered rca_request vops xconsole_dixi xosdkill xosd \
	dixi_test add_resource_to_vo request_vo_certificate rca_vo rca_resource_vo \
	xreservation rca_unregister
do
  %{__ln_s} %{dixidir}/dixi_run.sh $script
done


%{__mkdir_p} %{buildroot}%{tomcathome}/.xos
%{__ln_s}  %{_sysconfdir}/xos/config/AEMDemo.conf %{buildroot}%{tomcathome}/.xos/XATIConfig.conf

pushd %{buildroot}%{_javadir}
ln -sf axis2-kernel-1.2.jar axis2-kernel.jar
ln -sf mina-core-1.1.5.jar mina-core.jar
ln -sf mina-filter-ssl-1.1.5.jar mina-filter-ssl.jar
ln -sf velocity-dep-1.5.jar velocity-dep.jar
ln -sf slf4j-api-1.5.0.jar slf4j-api.jar
ln -sf slf4j-simple-1.5.0.jar slf4j-simple.jar
#ln -sf log4j-over-slf4j-1.5.0.jar log4j-over-slf4j.jar
popd

cp -p %{SOURCE8} %{buildroot}%{_sbindir}/setup_xosdconfig
chmod 755 %{buildroot}%{_sbindir}/setup_xosdconfig

%{__ln_s} %{_javadir}/rcalib.jar %{buildroot}%{dixidir}/libs/rcalib.jar


%clean
rm -rf $RPM_BUILD_ROOT

%post main
%{__mkdir_p} %{_sysconfdir}/xos/config
ln -sf %{_javadir}/log4j.jar %{dixidir}/libs/log4j.jar
%_post_service xosd

%preun main
%_preun_service xosd

%post cxati
%_post_service jsdl-exec

%preun cxati
%_preun_service jsdl-exec

%files main
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)

%{_javadir}/DIXIMain.jar
%{dixidir}/log4j_xati.properties
%{dixidir}/log4j.properties
%attr(755,root,root) %{dixidir}/dixi_run.sh
%{_initrddir}/xosd
%attr(755,root,root) %{dixidir}/kill_dixi.sh
%attr(755,root,root) %{dixidir}/killtree.sh


%{dixidir}/libs/*.jar
%{_bindir}/rca_apply
%{_bindir}/rca_confirm
%{_bindir}/rca_info
%{_bindir}/rca_list_pending
%{_bindir}/rca_list_registered
%{_bindir}/rca_unregister
%{_bindir}/rca_request
%{_bindir}/vops
%{_bindir}/xconsole_dixi
%{_bindir}/xosdkill
%{_bindir}/xosd
%{_bindir}/dixi_test
%{_bindir}/add_resource_to_vo
%{_bindir}/request_vo_certificate
%{_sbindir}/setup_xosdconfig

%files main-jardeps
%defattr(-,root,root)
%{_javadir}/axis2-kernel-1.2.jar
%{_javadir}/axis2-kernel.jar
%{_javadir}/mina-core-1.1.5.jar
%{_javadir}/mina-core.jar
%{_javadir}/mina-filter-ssl-1.1.5.jar
%{_javadir}/mina-filter-ssl.jar
%{_javadir}/velocity-dep-1.5.jar
%{_javadir}/velocity-dep.jar
%{_javadir}/slf4j-api-1.5.0.jar
%{_javadir}/slf4j-api.jar
%{_javadir}/slf4j-simple-1.5.0.jar
%{_javadir}/slf4j-simple.jar
#%{_javadir}/log4j-over-slf4j-1.5.0.jar
#%{_javadir}/log4j-over-slf4j.jar

%files services
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{xosdstagesdir}/DaemonGlobal.stage
%config(noreplace) %{xosdstagesdir}/XMLExtractor.stage
%config(noreplace) %{xosdstagesdir}/CronDaemon.stage
%{dixidir}/libs/rcalib.jar
%{_javadir}/DIXIMainServices.jar
%{dixidir}/XMLExtractor

%files xati
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%{_bindir}/rca_vo
%{_bindir}/rca_resource_vo
%{_bindir}/xreservation

%{_javadir}/xati.jar
%{dixidir}/XMLExtractor/Schemas/MetricsDesc.xsd
%{dixidir}/XMLExtractor/Schemas/JobInfoList.xsd
%{dixidir}/xtest.sh
%{dixidir}/tests/testSRDSMng.sh

%files cxati
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{_initrddir}/jsdl-exec
%{_bindir}/xjobKill
%{_bindir}/xps
%{_bindir}/xsub
%{_bindir}/xsubMPI
%{_bindir}/xwait
%{_bindir}/xsub.sh
%{_bindir}/xsubwrapper
%{_bindir}/xtrace
%{_bindir}/XOSExec
%{_bindir}/XOSJobDaemon
%{_bindir}/xjob

%{dixidir}/lib/libXATICA.a

%files devel
%{_includedir}/*.h

%files aem-node
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/pam.d/aem
%config(noreplace) %{_initrddir}/amond
%config(noreplace) %{xosdstagesdir}/ExecMng.stage
%config(noreplace) %{xosdstagesdir}/ResourceMonitor.stage
%config(noreplace) %{xosdstagesdir}/SRDSMng.stage
%config(noreplace) %{xosdstagesdir}/ResAllocator.stage
%{_bindir}/amond
%{_javadir}/aem-node.jar
%{dixidir}/stop_scalaris.sh

%{dixidir}/stop_bamboo.sh
%{dixidir}/rss_tracker.sh

%defattr(755,root,root)
%{dixidir}/bin/XOS_mpirun
%{dixidir}/bin/mpirun.xtreemosmpi
%{dixidir}/bin/mpirun.xtreemosmpipg
%{dixidir}/ExecMng
%{dixidir}/CRExecMng
%{dixidir}/ResourceMonitor


%files aem-server
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{xosdstagesdir}/JobMng.stage
%config(noreplace) %{xosdstagesdir}/JobDirectory.stage
%config(noreplace) %{xosdstagesdir}/ResMng.stage
%config(noreplace) %{xosdstagesdir}/ReservationManager.stage
%{_javadir}/aem-server.jar

%files vom-rca-node
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{xosdstagesdir}/RCAClient.stage
%{_sysconfdir}/xos/truststore/certs
#%{_sysconfdir}/xos/truststore/certs/incoming
%{_sysconfdir}/xos/truststore/private
%{_javadir}/security-services-rca-node.jar

%files vom-rca-server
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{xosdstagesdir}/RCAServer.stage
%{_javadir}/security-services-rca-server.jar

%files vom-vops
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%config(noreplace) %{xosdstagesdir}/VOPS.stage
%{_javadir}/security-services-vops.jar
%{dixidir}/VOPS

%files javadoc
%defattr(-,root,root)
%doc Support/Documentation

%files aemdemo
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/xos/config/AEMDemo.conf
%config(noreplace) %{tomcathome}/.xos/XATIConfig.conf
/var/lib/tomcat5/webapps/AEMDemo.war
%doc README.txt



%changelog 
* Fri Jun 05 2009 - peter.linnell@irisa.fr
- readd the exec bit to some scripts so they run on startup
